png++ 0.2.10

Public Types | Public Member Functions | List of all members
png::packed_pixel_row< pixel > Class Template Reference

The packed pixel row class template. More...

`#include <pixel_buffer.hpp>`

## Public Types
typedef detail::const_packed_pixel_proxy< pixel > | const_pixel_proxy
| The immutable packed pixel proxy type.
typedef detail::packed_pixel_proxy< pixel > | pixel_proxy
| The mutable packed pixel proxy type.

## Public Member Functions
| packed_pixel_row (size_t size=0)
| Constructs a pixel row object for `size` packed pixels.
size_t | size () const
void | resize (size_t size)
| Resizes the pixel row to hold up to `size` packed pixels.
const_pixel_proxy | at (size_t index) const
| Returns an immutable proxy the to the pixel at `index`.
pixel_proxy | at (size_t index)
| Returns a mutable proxy the to the pixel at `index`.
const_pixel_proxy | operator[] (size_t index) const
| Returns an immutable proxy the to the pixel at `index`. The non-checking version.
pixel_proxy | operator[] (size_t index)
| Returns n mutable proxy the to the pixel at `index`. The non-checking version.
byte * | get_data ()
| Returns the starting address of the row.

## Detailed Description

template<class pixel>
class png::packed_pixel_row< pixel >

The packed pixel row class template.

Stores the pixel row as a std::vector of byte-s, providing access to individual packed pixels via proxy objects.

## Member Typedef Documentation

## ◆ const_pixel_proxy

template<class pixel>

typedef detail::const_packed_pixel_proxy< pixel > png::packed_pixel_row< pixel >::const_pixel_proxy

The immutable packed pixel proxy type.

## ◆ pixel_proxy

template<class pixel>

typedef detail::packed_pixel_proxy< pixel > png::packed_pixel_row< pixel >::pixel_proxy

The mutable packed pixel proxy type.

## Constructor & Destructor Documentation

## ◆ packed_pixel_row()

template<class pixel>

png::packed_pixel_row< pixel >::packed_pixel_row | ( | size_t | size = 0 | ) |
| inline explicit

Constructs a pixel row object for `size` packed pixels.

## Member Function Documentation

## ◆ size()

template<class pixel>

size_t png::packed_pixel_row< pixel >::size | ( |  | ) | const
| inline

## ◆ resize()

template<class pixel>

void png::packed_pixel_row< pixel >::resize | ( | size_t | size | ) |
| inline

Resizes the pixel row to hold up to `size` packed pixels.

Referenced by png::packed_pixel_row< pixel_type >::packed_pixel_row().

## ◆ at() [1/2]

template<class pixel>

const_pixel_proxy png::packed_pixel_row< pixel >::at | ( | size_t | index | ) | const
| inline

Returns an immutable proxy the to the pixel at `index`.

## ◆ at() [2/2]

template<class pixel>

pixel_proxy png::packed_pixel_row< pixel >::at | ( | size_t | index | ) |
| inline

Returns a mutable proxy the to the pixel at `index`.

## ◆ operator[]() [1/2]

template<class pixel>

const_pixel_proxy png::packed_pixel_row< pixel >::operator[] | ( | size_t | index | ) | const
| inline

Returns an immutable proxy the to the pixel at `index`. The non-checking version.

## ◆ operator[]() [2/2]

template<class pixel>

pixel_proxy png::packed_pixel_row< pixel >::operator[] | ( | size_t | index | ) |
| inline

Returns n mutable proxy the to the pixel at `index`. The non-checking version.

## ◆ get_data()

template<class pixel>

byte * png::packed_pixel_row< pixel >::get_data | ( |  | ) |
| inline

Returns the starting address of the row.

Referenced by png::row_traits< packed_pixel_row< pixel > >::get_data().

The documentation for this class was generated from the following file:

- pixel_buffer.hpp